.386
.model flat, stdcall
option casemap:none

include		\masm32\include\windows.inc
include		\masm32\include\kernel32.inc
include		\masm32\include\user32.inc
include		\masm32\macros\macros.asm
include		PEmem.inc

includelib	\masm32\lib\kernel32.lib
includelib	\masm32\lib\user32.lib
includelib	\masm32\lib\masm32.lib
includelib	lib\PEmem.lib

EXTERN	pDLL:PTR BYTE                         	; pointer to ConsoleOut.dll linked together with
							; the main executable

.data

DLLfunc	db 'StdOut',0 ; StdOut function from consfunc.dll
message	db 'StdOut function - DLL in memory test',0
errmessage1	db 'could not load the DLL',0
errmessage2	db 'GetProcAddr cannot find the address',13,10
		db 'of the requested function',0
caption		db 'Error',0

.data?

hVirtModule	dd ?                                  ; handle to the "virtual" module consfunc.dll
pEntry		dd ?

.code

start:

	invoke	LoadEXEfromMem,ADDR pDLL,ADDR pEntry
	test	eax,eax
	jnz	@f
	invoke	MessageBox,0,ADDR errmessage1,ADDR caption,MB_ICONERROR
	jmp	finish2                          
@@:
	mov	hVirtModule,eax
	invoke	GetProcAddr,eax,ADDR DLLfunc	; GetProcAddr gets the address of StdOut
							; from the "virtual" consfunc.dll
	test	eax,eax
	jnz	@f
	invoke  MessageBox,0,ADDR errmessage2,ADDR caption,MB_ICONERROR
	jmp	finish1

@@:
	push	OFFSET message
	call	eax					; eax holds the address of StdOut taking one parameter
							; to write the NULL terminated string to the console
finish1:

	invoke	FreeEXEfromMem,hVirtModule            ; Release the memory allocated

finish2:

	invoke  ExitProcess,0

END start     