.386
.model flat,stdcall
option casemap:none

EXTERN	Resource:PTR BYTE

include		\masm32\include\windows.inc
include		\masm32\include\user32.inc
include		\masm32\include\kernel32.inc
includelib	\masm32\lib\user32.lib
includelib	\masm32\lib\kernel32.lib

DlgProc	PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data
msg		db 'Dialog box with menu',0
title1		db 'Hello!',0

IDM_HELLO	equ 11
IDM_EXIT	equ 12
IDC_HELLO	equ 110
IDC_EXIT	equ 120
IDC_EDIT	equ 3000

.code

start:

	invoke	GetModuleHandle,0
	invoke	DialogBoxIndirectParam,eax,ADDR Resource,NULL,ADDR DlgProc,NULL
	ret		; Use ret instead of ExitProcess to return to the main executable PEmem

DlgProc PROC hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	
	.IF uMsg==WM_INITDIALOG

		invoke	LoadIcon,NULL,IDI_APPLICATION	
		invoke	SendMessage,hWnd,WM_SETICON,ICON_SMALL,eax
		lea	eax,[Resource+084h]
		invoke	LoadMenuIndirect,eax
		invoke	SetMenu,hWnd,eax
        
	.ELSEIF uMsg==WM_CLOSE

		invoke SendMessage,hWnd,WM_COMMAND,IDM_EXIT,0

	.ELSEIF uMsg==WM_COMMAND
		
		mov eax,wParam
		.IF lParam==0
			.IF ax==IDM_HELLO
				invoke MessageBox,NULL,ADDR msg,ADDR title1,MB_OK
			.ELSEIF ax==IDM_EXIT
                                @@:
				invoke EndDialog,hWnd,0
			.ENDIF
		.ELSE
			mov edx,wParam
			shr edx,16
			.IF dx==BN_CLICKED
				.IF ax==IDC_HELLO
					invoke SendMessage,hWnd,WM_COMMAND,IDM_HELLO,0
				.ELSEIF ax==IDC_EXIT
					jmp @b
				.ENDIF
			.ENDIF
		.ENDIF
	.ELSE
		mov eax,FALSE
		ret
	.ENDIF
	mov eax,TRUE
	ret
DlgProc ENDP

END start